%% HW4 - The Hodgkin and Huxley model - FRTF01
% Department of Automatic Control, Lund University

%% Section 1 - Model parameters
% Na - sodium, K - potassium, L - Leakage

% Membrane capacitance [microF/cm^2]
C_m  = % fill in
% Nernst reversal potentials [mV]
E_Na = % fill in
E_K  = % fill in
E_L  = % fill in
% Maximum conductances [mS/cm^2]
g_Na =  % fill in
g_K =   % fill in
g_L  = % fill in

%% Section 2 - Channel gating kinetics, rate functions
% Functions of membrane voltage
alpha_m = @(V) % fill in
beta_m = @(V)  % fill in
alpha_h = @(V) % fill in
beta_h = @(V)  % fill in
alpha_n = @(V) % fill in
beta_n = @(V)  % fill in

%% Section 3 - Membrane currents (in microA/cm^2)
I_Na = @(V,m,h) % fill in
I_K = @(V,n) % fill in
I_L = @(V) % fill in

%% Section 4 - External current
I_ext = @(t) % fill in

%% Section 5 - Declaring the differential equations
% Define X = [V,m,h,n];

dAlldt = @(t,X) % fill in

%% Section 6 - Steady state

% Initial values = [V(0), m(0), h(0), n(0)]
initial_values = [0 0 0 0]; 
tspan = [0 500]; % Time span 0-500 [ms]

[t, X] = ode45(dAlldt, tspan, initial_values);

V = X(:,1); % 1st column is the V values
m = X(:,2); % 2nd column is the m values
h = X(:,3); % 3rd column is the h values
n = X(:,4); % 4th column is the n value

figure(1)
subplot(3,1,1)
plot(t, V, 'k')
title('1A: Find steady state values')
ylabel('V (mV)')
xlabel('t (ms)')

subplot(3,1,2)
plot(t, m, 'r')
hold on
plot(t, h, 'b')
plot(t, n, 'g')
ylabel('Gating Value')
xlabel('t (ms)')
legend('m', 'h', 'n', 'Location','SouthEast')

subplot(3,1,3)
plot(t, I_ext(t), 'k')
xlabel('t (ms)')
ylabel('I_{ext} (\mu{A}/cm^2)')
ylim([-1 max(I_ext(t))+1])


%% Section 7 -  Find the threshold potential and specify the refractory period

initial_values = []; % Fill in the values you determined in Section 6
k = % use different k-values to determine the threshold potential
I_ext = @(t) k*floor(t/100); % use help floor to understand what it does

% Define the diff eq again with the new I_ext.
dAlldt = @(t,X) % fill in

% Run the section to create the figure with the new I_ext
[t, X] = ode45(dAlldt, tspan, initial_values);

V = X(:,1); m = X(:,2); h = X(:,3); n = X(:,4);

figure(2)
subplot(3,1,1);
plot(t, V, 'k');
title('Find the threshold potential and refractory period')
ylabel('V (mV)');
xlabel('t (ms)')

subplot(3,1,2);
plot(t, m, 'r');
hold on
plot(t, h, 'b');
plot(t, n, 'g');
ylabel('Gating Value')
xlabel('t (ms)')
legend('m', 'h', 'n', 'Location','SouthEast')

subplot(3,1,3);
plot(t, I_ext(t), 'k');
xlabel('t (ms)');
ylabel('I_{ext} (\mu{A}/cm^2)');
ylim([-1 max(I_ext(t))+1]);
